// **************************************************************************
//
// Commodore Basic V3.5 detokenizer V0.00
//
// Copyright (C) 1997 MicroWizard (Nagy Tams)
// This program is free. You can copy, modify, delete and anything else
// what you want (and can) with this program.
//
// BUT I (Nagy Tams) am not liable for anything caused by this program.
//
// **************************************************************************
//
// Compile with Symantec C/C++ 6.1 without any switch
// under any type of DOS, DOS-Box, DOS-EMU, etc.
// (real mode, small memory modell, without optimization)
//
// It should work with any other C/C++ compiler, I hope.
//
// The program isn't too complicated if you know the C language.
// I don't plan to enhance it, because it's full of features for my purpose.
// The listing can be printed if you have a printer wide enough. :-)
//
// The program cannot handle all of the Commodore control codes
// and escape sequences and do not translate the awful graphic characters.
//
// If you want to contact me try E-mail to: MicroWizard@CompuServe.com

#include <stdio.h>

typedef unsigned char byte;
typedef unsigned short word;

// Commodore tokens $80-...
char *token[]={
	"end","for","next","data","input#","input","dim","read","let","goto",
	"run","if","restore","gosub","return","rem","stop","on","wait","load",
	"save","verify","def","poke","print#","print","cont","list","clr","cmd",
	"sys","open","close","get","new","tab(","to","fn","spc(","then","not",
	"step",
	"+","-","*","/","^","and","or","<","=",">",
	"sgn","int","abs","usr","fre","pos","sqr","rnd","log","exp","cos","sin",
	"tan","atn","peek","len","str$","val","asc","chr$","left$","right$",
	"mid$","go","rgr","rclr","rlum","joy","rdot","dec","hex$","err$","instr",
	"else","resume","trap","tron","troff","sound","vol","auto","pudef",
	"graphic","paint","char","box","circle","gshape","sshape","draw",
	"locate","color","scnclr","scale","help","do","loop","exit","directory",
	"dsave","dload","header","scratch","collect","copy","rename","backup",
	"delete","renumber","key","monitor","using","until","while"
};

// replacement for Commodore control codes (between '"' marks) $00-$1F
char *ctrlcode[]={
	"<nul>","<01>","<02>","<03>","<04>","<05>","<06>","<07>",
	"<08>","<09>","<10>","<11>","<12>","<13>","<14>","<15>",
	"<16>","<17>","<18>","<19>","<bckspc>","<21>","<22>","<23>",
	"<24>","<25>","<26>","<esc>","<28>","<29>","<30>","<31>",
};

int detoken(char *fname,char *fout)
{
	byte idezojel=0;
	FILE *be=fopen(fname,"rb");
	if (be==NULL)
	{
		fprintf(stderr,"Error opening input file.\n");
		return -1;
	}
	FILE *ki=fopen(fout,"wb");
	if (ki==NULL)
	{
		fprintf(stderr,"Error opening output file.\n");
		return -1;
	}
	byte l=fgetc(be);
	byte h=fgetc(be);

	while(!feof(be))
	{
		// all BASIC lines start with these awful things
		byte l=fgetc(be);	// low byte
		byte h=fgetc(be);	// high byte
		word a=(h<<8)|l;	// link pointer
		if (a==0)			// end-of-program program, link pointer = NULL
		{
			break;			// quit
		}

		l=fgetc(be);
		h=fgetc(be);		// BASIC line number (do you remember ?)
		a=(h<<8)|l;
		fprintf(ki,"%5d ",a);

		do
		{
			byte b=fgetc(be);

			// End-of-line marker
			if (b==0)
			{
				idezojel=0;
				fprintf(ki,"\r\n");
				break;
			}

			// process control codes (if YOU want more ... probably ESC)
			switch(b)
			{
				case 27:
					// handle escape ...
					break;
				case 34:
					idezojel=!idezojel;
					break;
			}

			if ((b & 0x80) && (!idezojel))
			{
				fprintf(ki,"%s",token[b&0x7f]);
			}
			else if (b)
			{
				if (b<32)
				{
					fprintf(ki,"%s",ctrlcode[b]);
				}
				else
				{
					// translate upper and lower case characters
					if ((b>=0x41) && (b<=0x5a))		// lower case
					{
						fprintf(ki,"%c",b|0x20);
					}
					else if ((b>=0xc1) && (b<=0xda))// upper case
					{
						fprintf(ki,"%c",b&(~0x80));
					}
					else							// else (you see)
					{
						fprintf(ki,"%c",b);
					}
				}
			}
		}while(1);
	}
	fclose(be);
	return 0;
}

void main(int argc,char** argv)
{
	fprintf(stderr,"Commodore BASIC V3.5 program lister V0.00\n");
	fprintf(stderr,"(C) 1997 MicroWizard\n");

	if (argc!=3)
	{
		fprintf(stderr,"Argument error.\n");
		fprintf(stderr,"Usage: detoken <infile.ext> <outfile.ext>\n");
		return;
	}

	// input file,output file
	if (!detoken(argv[1],argv[2]))
	{
		fprintf(stderr,"Done.\n");
	}
}


